static char *rcsId = "$Header: /misc/hadaq/cvsroot/hadaq/agent.c,v 6.15 2004/08/16 15:02:12 hadaq Exp $";

#define _GNU_SOURCE
#include <unistd.h>
#include <rpc/rpc.h>
#include <syslog.h>
#include "agent.h"
#include "worker.h"

#define NWORKERS 16
char workers[NWORKERS][32];		/* inplicitly set to zero */

static int addWorker(const char *worker)
{
	int i;

	for (i = 0; strcmp(workers[i], "") != 0; i++) {
		/* BUGBUG crash if workers full */
	}
	strcpy(workers[i], worker);

	return i;
}

static char *getWorker(int id)
{
	return workers[id];
}

static void removeWorker(int id)
{
	strcpy(workers[id], "");
}

int *rpcworker_start_1(RpcWorker_startArgs * args, CLIENT * cl)
{
	static int retVal;
	Worker *worker;
	int i;
	char **argv;

	/* The closing NULL in argv cannot be passed via rpc, we have to add it
	   here */

	argv = malloc((args->argv.argv_len + 1) * sizeof(char *));

	for (i = 0; i < args->argv.argv_len; i++) {
		argv[i] = args->argv.argv_val[i];
	}
	argv[i] = NULL;

	openlog("daq_agent", LOG_PID | LOG_PERROR, LOG_LOCAL0);
	setlogmask(LOG_UPTO(LOG_INFO));

	Worker_start(args->name, argv);

	closelog();

	retVal = addWorker(argv[0]);

	free(argv);

	return &retVal;
}

int *rpcworker_start_1_svc(RpcWorker_startArgs * dummy, struct svc_req *x)
{
	return rpcworker_start_1(dummy, NULL);
}

char **rpcworker_status_1(int *id, CLIENT * cl)
{
	static char *retVal;
	char *worker;

	openlog("daq_agent", LOG_PID | LOG_PERROR, LOG_LOCAL0);
	setlogmask(LOG_UPTO(LOG_INFO));

	worker = getWorker(*id);
	if (*worker != '\0') {
		retVal = Worker_status(worker);
	} else {
		retVal = "{}";
	}

	closelog();

	return &retVal;
}

char **rpcworker_status_1_svc(int *dummy, struct svc_req *x)
{
	return rpcworker_status_1(dummy, NULL);
}

int *rpcworker_stop_1(int *id, CLIENT * cl)
{
	static int retVal;
	char *worker;

	openlog("daq_agent", LOG_PID | LOG_PERROR, LOG_LOCAL0);
	setlogmask(LOG_UPTO(LOG_INFO));

	worker = getWorker(*id);
	if (*worker != '\0') {
		Worker_stop(worker, 15);
	}

	closelog();

	removeWorker(*id);

	retVal = 0;

	return &retVal;
}

int *rpcworker_stop_1_svc(int *dummy, struct svc_req *x)
{
	return rpcworker_stop_1(dummy, NULL);
}

void *rpcsystem_1(char **command, CLIENT * cl)
{
	static int retVal;

	retVal = system(*command);

	return &retVal;
}

void *rpcsystem_1_svc(char **dummy, struct svc_req *x)
{
	return rpcsystem_1(dummy, NULL);
}

int *rpcjoin_1(int *dummy, CLIENT * cl)
{
	static int retVal;

	retVal = 0;

	return &retVal;
}

int *rpcjoin_1_svc(int *dummy, struct svc_req *x)
{
	return rpcjoin_1(dummy, NULL);
}
