#!/usr/bin/tclsh -f
source cmds.tcl
source [lindex $argv 1]

foreach i [agent cat] {
	set host [agent list $i host]
	set user [agent list $i user]
	set dir [agent list $i dir]

	puts $host 
	set hostType [ exec rsh $host -l $user uname ]
	if {[string match "LynxOS" $hostType]} {
		set psCmd {ps -ax | awk '{ print $1, $NF }'}
	} else {
		set psCmd {export UNIX95=XPG4; ps -eo pid,comm}
	}

	if {[lindex $argv 0] == "stop" || [lindex $argv 0] == "restart"} {
		set cmd "kill `$psCmd | awk '\$2 ~ /daq_/ { print \$1 }'`"
		catch {exec rsh $host -l $user "$cmd"}
	}

	if {[lindex $argv 0] == "start" || [lindex $argv 0] == "restart"} {
		catch {exec mv hadaq.log hadaq.log.old}
		eval exec "rsh $host -l $user sh -c {'cd $dir; ./daq_agent'}" </dev/null >>&hadaq.log &
		exec cat hadaq.log
	}
}
