
#ifndef HADTUQUEUE_H
#define HADTUQUEUE_H

#include <stddef.h>
#include "hadtu.h"

typedef struct HadTuQueueS HadTuQueue;

typedef enum HadTuQueueProtE {
	HadTuQueueProt_read,
	HadTuQueueProt_write
} HadTuQueueProt;

void conHadTuQueue(HadTuQueue *my, void *mem, size_t size);
void conHadTuQueue_voidP(HadTuQueue *my, void *mem);
void desHadTuQueue(HadTuQueue *my);
size_t HadTuQueue_sizeOf(void);
void HadTuQueue_cntl(HadTuQueue *my, int flag);
void HadTuQueue_clear(HadTuQueue *my);
int HadTuQueue_invariant(const HadTuQueue *my);

int HadTuQueue_empty(const HadTuQueue *my);
size_t HadTuQueue_size(const HadTuQueue *my);
void *HadTuQueue_alloc(const HadTuQueue *my, size_t size);
void HadTuQueue_push(HadTuQueue *my);
void *HadTuQueue_2voidP(const HadTuQueue *my);
void *HadTuQueue_front(const HadTuQueue *my);
void HadTuQueue_pop(HadTuQueue *my);

#endif
