
#ifndef HARDWARE_H
#define HARDWARE_H

#include <syslog.h>

typedef struct HardwareS Hardware;

int readoutMain(int argc, char *argv[]);

Hardware *newHardware();		/* allowed as newHardware(void) and newHardware(const char *subsystem) UFN */
void deleteHardware(Hardware *my);
int Hardware_inSpill(const Hardware *my);
size_t Hardware_maxSubEvtSize(const Hardware *my);
void Hardware_waitForTrigger(Hardware *my, void *subEvt);
void Hardware_readout(Hardware *my, void *subEvt);

static int getCards(Param *param, const char *subsystem, const char *cardtype, int *nCards, char **cards)
{
	int getCardsR;
	int i;
	char unitsS[PARAM_MAX_ARRAY_LEN][PARAM_MAX_VALUE_LEN];
	char *units[PARAM_MAX_ARRAY_LEN];
	int r;

	for (i = 0; i < PARAM_MAX_ARRAY_LEN; i++) {
		units[i] = unitsS[i];
	}

	if (0 > Param_getStringArray(param, subsystem, "unit", PARAM_MAX_ARRAY_LEN, &r, units) || r == 0) {
		getCardsR = -1;
		syslog(LOG_ERR, "Parameter %s(unit) not found, unknown list of VME modules", subsystem);
	} else {
		int unit;
		int card;

		getCardsR = 0;
		card = 0;
		for (unit = 0; unit < r; unit++) {
			char ct[PARAM_MAX_VALUE_LEN];
			int r;

			if (Param_getString(param, units[unit], "cardtype", &r, ct) || r == 0) {
				syslog(LOG_ERR, "Parameter %s(cardtype) not found", units[unit]);
				getCardsR = -1;
			} else {
				if (strcmp(cardtype, ct) == 0) {
					strcpy(cards[card++], units[unit]);
				}
			}
		}
		*nCards = card;
	}

	if (0 == getCardsR) {
		int card;

		syslog(LOG_INFO, "List of matching cards for subsystem %s, cardtype %s", subsystem, cardtype);
		for (card = 0; card < *nCards; card++) {
			syslog(LOG_INFO, "%s", cards[card]);
		}
	}
	return getCardsR;
}

#endif
