static char *rcsId = "$Header: /misc/hadaq/cvsroot/hadaq/online.c,v 6.10 2004/08/16 11:25:53 hadaq Exp $";


#define _GNU_SOURCE

#include <errno.h>
#include <stdio.h>
#include <rpc/rpc.h>


#include "evt.h"
#include "online.h"

static void *ourEvt;

extern void daqprog_1();

static struct timeval timeout = { 0, 0 };

static SVCXPRT *ourTransp;

initOnline()
{

	(void) pmap_unset(DAQPROG, DAQVERS);

	ourTransp = svctcp_create(RPC_ANYSOCK, 0, 0);
	if (ourTransp == NULL) {
		fprintf(stderr, "cannot create tcp service.");
		return -1;
	}
	if (!svc_register(ourTransp, DAQPROG, DAQVERS, daqprog_1, IPPROTO_TCP)) {
		fprintf(stderr, "unable to register (DAQPROG, DAQVERS, tcp).");
		return -1;
	}
	return 0;
}

int finiOnline(void)
{
	svc_unregister(DAQPROG, DAQVERS);
	svc_destroy(ourTransp);
}

void Evt_online(void *evt)
{
	fd_set readfdset;
	static int tsize = 0;

	if (tsize == 0) {
		tsize = getdtablesize();
	}
	readfdset = svc_fdset;

	switch (select(tsize, &readfdset, (fd_set *) NULL, (fd_set *) NULL, &timeout)) {
	case -1:
		if (errno != EBADF) {
			perror("select");
			return;
		}
		break;
	case 0:
		break;
	default:
		ourEvt = evt;
		svc_getreqset(&readfdset);
		break;
	}
	return;
}

rpcevt *onlineevt_1(void *dummy, CLIENT * cl)
{
	static rpcevt result;

	result.rpcevt_len = Evt_paddedSize(ourEvt);
	result.rpcevt_val = (char *) ourEvt;

	return &result;
}

rpcevt *onlineevt_1_svc(void *dummy, struct svc_req * x)
{
	return onlineevt_1(dummy, NULL);
}
