
#ifndef SHMTRANS_H
#define SHMTRANS_H

#ifndef _POSIX_SEMAPHORES
#error POSIX_SEMAPHORES not available on this OS
#endif

#include <limits.h>
#include <semaphore.h>
//#include "../compat/semaphore.h"

#include "psxshm.h"

#include "hadtuqueue.h"

typedef struct ShmTransS {
	char name[_POSIX_PATH_MAX];
	PsxShm *shm;
	HadTuQueue *rdQueue;
	HadTuQueue *wrQueue;
	sem_t *switchRequest;
	sem_t *switchComplete;
}

ShmTrans;

ShmTrans *ShmTrans_create(const char *name, size_t size);
ShmTrans *ShmTrans_open(const char *name, size_t size);
void ShmTrans_close(ShmTrans *my);
void ShmTrans_remove(ShmTrans *my);

void *ShmTrans_alloc(ShmTrans *my, size_t size);
void *ShmTrans_tryAlloc(ShmTrans *my, size_t size);
void ShmTrans_requestSpace(ShmTrans *my);
void ShmTrans_send(ShmTrans *my);
void *ShmTrans_recv(ShmTrans *my);
void *ShmTrans_recvWhole(ShmTrans *my);
void *ShmTrans_tryRecv(ShmTrans *my);
void ShmTrans_requestData(ShmTrans *my);
void ShmTrans_free(ShmTrans *my);
void ShmTrans_freeWhole(ShmTrans *my);

#endif
