static char *rcsId = "$Header: /misc/hadaq/cvsroot/hadaq/sniff.c,v 6.11 2003/05/15 15:31:27 muench Exp $";


#define SYSLOG_NAMES
#define _GNU_SOURCE
#include <unistd.h>

#include <rpc/rpc.h>
#include <stdio.h>
#include <stdlib.h>
#include <syslog.h>
#include <time.h>

#include "online.h"

main(int argc, char *argv[])
{
	extern char *optarg;
	CLIENT *cl;
	char *server;
	int i;
	struct timespec t =
	{5, 0};
	struct rpc_err rpcErrS, *rpcErr = &rpcErrS;
	rpcevt rpcEvtS, *rpcEvt = &rpcEvtS;

	openlog(argv[0], LOG_PID | LOG_PERROR, LOG_LOCAL0);
	setlogmask(LOG_UPTO(LOG_INFO));



	server = NULL;

	while ((i = getopt(argc, argv, "v:h:")) != -1) {
		switch (i) {
		case 'h':
			server = optarg;
			break;
		case 'v':
			for (i = 0; prioritynames[i].c_name != NULL
				 && 0 != strcmp(prioritynames[i].c_name, optarg); i++) {
			}
			if (prioritynames[i].c_name != NULL) {
				setlogmask(LOG_UPTO(prioritynames[i].c_val));
				break;
			}					/* FALLTHROUGH to default */
		default:
			syslog(LOG_ERR, "Usage: %s -h evtBuildHost", argv[0]);
			exit(EXIT_FAILURE);
			break;
		}
	}

	if (server == NULL) {
		syslog(LOG_ERR, "Usage: %s -h evtBuildHost", argv[0]);
		exit(EXIT_FAILURE);
	}
	while (1) {
		if (NULL == (cl = clnt_create(server, DAQPROG, DAQVERS, "tcp"))) {
			syslog(LOG_INFO, "online server not running, trying to connect");
			syslog(LOG_DEBUG, "%s, %d: %s", __FILE__, __LINE__, clnt_spcreateerror(server));
			nanosleep(&t, NULL);
		} else {
			do {
				if (NULL == (rpcEvt = onlineevt_1(NULL, cl))) {
					clnt_geterr(cl, rpcErr);
					switch (rpcErr->re_status) {
					case RPC_TIMEDOUT:
						break;
					case RPC_CANTRECV:
						syslog(LOG_INFO, "server shutdown, trying to reconnect");
						syslog(LOG_DEBUG, "%s, %d: %s", __FILE__, __LINE__, clnt_sperror(cl, "onlineevt_1"));
						break;
					default:
						syslog(LOG_ERR, "%s, %d: %s", __FILE__, __LINE__, clnt_sperror(cl, "onlineevt_1"));
						break;
					}
				} else {
					fwrite(rpcEvt->rpcevt_val, 1, rpcEvt->rpcevt_len, stdout);
					xdr_free((xdrproc_t) xdr_rpcevt, (caddr_t) rpcEvt);
				}
			} while (rpcErr->re_status != RPC_CANTRECV);
			clnt_destroy(cl);
		}
	}
	exit(0);
}
