static char *rcsId = "$Header: /misc/hadaq/cvsroot/hadaq/subevt.c,v 6.12 2003/05/14 13:54:45 muench Exp $";


#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>

#include "subevt.h"

uint32_t SubEvt_dataValue(const void *my, unsigned idx)
{
	uint32_t val;

	switch (SubEvt_alignment(my)) {
	case 4:
		if (SubEvt_isSwapped(my)) {
			uint32_t tmp0;
			uint32_t tmp1;

			tmp0 = ((uint32_t *) SubEvt_data(my))[idx];
			((char *) &tmp1)[0] = ((char *) &tmp0)[3];
			((char *) &tmp1)[1] = ((char *) &tmp0)[2];
			((char *) &tmp1)[2] = ((char *) &tmp0)[1];
			((char *) &tmp1)[3] = ((char *) &tmp0)[0];
			val = tmp1;
		} else {
			val = ((uint32_t *) SubEvt_data(my))[idx];
		}
		break;
	case 2:
		if (SubEvt_isSwapped(my)) {
			uint16_t v;
			swab(((uint16_t *) SubEvt_data(my)) + idx, &v, 2);
			val = v;
		} else {
			val = ((uint16_t *) SubEvt_data(my))[idx];
		}
		break;
	default:
		val = ((uint8_t *) SubEvt_data(my))[idx];
		break;
	}
	return val;
}

char *SubEvt_2charP(const void *my)
{
	static char buf[132];

	sprintf(buf, "size: 0x%08x\tdecoding: 0x%08x\tid: 0x%08x\ttrigNr: 0x%08x",
			SubEvt_size(my), SubEvt_decoding(my), SubEvt_id(my), SubEvt_trigNr(my));

	return buf;
}

void *newSubEvt(uint32_t decoding, uint32_t id, uint32_t trigNr)
{
	void *my;

	my = malloc(SubEvt_hdrSize());

	SubEvt_setSize(my, SubEvt_hdrSize());
	SubEvt_setDecoding(my, decoding);
	SubEvt_setId(my, id);
	SubEvt_setTrigNr(my, trigNr);

	return my;
}

void deleteSubEvt(void *my)
{
	free(my);
}

void *SubEvt_appendData(void *my, const void *data, size_t size)
{

	my = realloc(my, SubEvt_paddedSize(my) + size);
	memcpy(SubEvt_end(my), data, size);
	SubEvt_setSize(my, SubEvt_paddedSize(my) + size);

	return my;
}
